Subject: Re: bug#14233: 24.3; Don't constrain frame size to character multiples

From: Eli Zaretskii <[email-masked]>
Date: Sat, 20 Apr 2013 21:26:02 +0300

> Date: Sat, 20 Apr 2013 19:35:18 +0200
> From: martin rudalics <[email-masked]>
> CC: [email-masked], [email-masked], [email-masked]
> 
>  >> One can check whether pixel-edges are equal.
>  >
>  > Yes, I think that's a better solution for that.
> 
> But we also should try to not break code outside our code base.

To some point, yes.  But in this case, I think there's no other way.
Or maybe introduce new APIs for pixel-unit resizing.

>  >> Also the frame's internal border is drawn in between toolbar and the
>  >> frame's root window
>  >
>  > At least on MS-Windows, I see no border.  Or perhaps I don't know what
>  > to look for.
> 
> With emacs -Q try
> 
> (set-frame-parameter (selected-frame) 'internal-border-width 12)

But that just proves that I was right: a tool bar is just another
window, so its size should be included in the frame's text height.
What am I missing?  What is exactly that we are disagreeing about
here?

>  >>  > As for display margins, they do display text, don't they?
>  >>
>  >> IIUC they could display anything fringes can display
>  >
>  > No.  Fringes can only display bitmaps.  The cannot display text or
>  > images that we support in the text area or on margins.
> 
> Yes.  But I meant that display margins can display images and bitmaps as
> well.

The fringes can display _only_ bitmaps.  No text or images of other
formats.

>  >> BTW, I've never been able to understand the manuals and doc-strings in
>  >> this regard.  Consider the doc-string of `set-frame-width': "Specify
>  >> that the frame FRAME has COLS columns."  Or its manual entry: "This
>  >> function sets the width of FRAME, measured in characters."
>  >
>  > What's wrong with those?
> 
> That they never explain what the "width of a frame" is.

Of course, they do.  Which part of "width of FRAME, measured in
characters" is unclear?

> The best explanation I could find is
> 
> http://www.xemacs.org/Documentation/21.5/html/internals_29.html#SEC275
> 
> (in particular section 29.7 "The Displayable Area") but it still lacks
> an explanation of frame fringe widths (maybe because XEmacs doesn't have
> them).

XEmacs has an entirely different display engine, developed
independently and with somewhat different goals.